(* camlp4r *)
(***********************************************************************)
(*                                                                     *)
(*                             Camlp4                                  *)
(*                                                                     *)
(*        Daniel de Rauglaudre, projet Cristal, INRIA Rocquencourt     *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* Id *)

type t = string * string;;
type pattern = string * string;;

exception Error of string;;

type location_function = int -> int * int;;

type lexer =
  { func : char Stream.t -> t Stream.t * location_function;
    using : pattern -> unit;
    removing : pattern -> unit;
    tparse : pattern -> t Stream.t -> string;
    text : pattern -> string }
;;
